//File: RELOGIOE.P (CLOCK-ENGLISH adaptation, ASM file is for for ZX-IDE http://www.sinclairzxworld.com/viewtopic.php?f=6&t=795)

// RELOGIO By K. Murta http://zx81.eu5.org/toddysofte.html
//
// "I made this little program to demonstrate the use
//  of ZX81 video routines to implementing a multi-task
//  application, in this case a digital clock that is
//  updated simultaneously with the execution of the
//  BASIC program.
//
//  Enter the time in HHMMSS format, counted with 24
//  hours. The digital clock is shown in the upper
//  right corner of the screen and a square traverses
//  the screen from one side to another. Stop the
//  program with BREAK and note that the clock is
//  still being updated. Clear the screen with CLS
//  or LIST the BASIC program, the clock is still
//  there and is only disabled with the commands
//  FAST, LLIST, LPRINT, PAUSE or editing any line of
//  the BASIC program."

format zx81
;labelusenumeric 
   MEMAVL     =       MEM_16K
   STARTMODE  EQU     SLOW_MODE
   include 'SINCL-ZX\ZX81.INC'
;LISTON
//AUTORUN:
// AUTOLINE 10

   1 REM _asm
     start:  ld      ix,relog
	     ld      (iy+$34),$ff
	     ret

     hor:    db      $00
     min:    db      $00
     seg:    db      $00

     relog:  ld      a,r	     ;normal screen
	     ld      bc,$1901
	     ld      a,$f5
	     call    $02b5	     ;processa o arquivo de tela (Dfile)
	     call    $0292	     ;retorna para a aplicao
	     call    $0220	     ;VSYNC

	     in      a,($fe)	     ;determina se  50 ou 60hz
	     rl      a		     ;bit 6 = 0 => 60hz
	     rl      a		     ;bit 6 = 1 => 50hz
	     sbc     a,a
	     and     $0a
	     add     a,$c3
	     ld      c,a
	     ld      a,($4034)	     ;FRAMES
	     cp      c
	     jr      nz,prtrl
	     ld      (iy+$34),$ff
	     ld      a,(seg)
	     inc     a
	     cp      $3c	     ;60 segundos?
	     ld      (seg),a
	     jr      c,prtrl
	     xor     a
	     ld      (seg),a
	     ld      a,(min)
	     inc     a
	     cp      $3c	     ;60 minutos?
	     ld      (min),a
	     jr      c,prtrl
	     xor     a
	     ld      (min),a
	     ld      a,(hor)
	     inc     a
	     cp      $18	     ;24 horas?
	     ld      (hor),a
	     jr      c,prtrl
	     xor     a
	     ld      (hor),a

     prtrl:  ld      hl,($400c)      ;imprime o relgio
	     ld      de,$0018
	     add     hl,de
	     ld      a,(hor)
	     call    prtnr
	     ld      (hl),$0e
	     ld      a,(min)
	     call    prtnr
	     ld      (hl),$0e
	     ld      a,(seg)
	     call    prtnr
	     ld      ix,relog	     ;salva o vetor da interrupo em ix
	     jp      $02a4	     ;retorna para a aplicao

     prtnr:  ld      e,a	     ;imprime dois dgitos
	     inc     hl
	     ex      de,hl
	     ld      bc,$0a
	     call    prtdig
	     ld      bc,$01
	     call    prtdig
	     ex      de,hl
	     ret

     prtdig: sub     a
	     ld      a,$1c
     jp1:    sbc     hl,bc
	     jr      c,jp2
	     inc     a
	     jr      jp1
     jp2:    add     hl,bc
	     ld      (de),a
	     inc     de
	     ret
     END _asm
  10 PRINT AT 10,0;"TELL ME THE TIME, FORMATTED AS  HHMMSS, WITH HOURS FROM 1 TO 24"
  20 INPUT H$
  30 IF LEN H$<>6 THEN GOTO 20
  40 POKE 16523,VAL H$( TO 2)
  50 POKE 16524,VAL H$(3 TO 4)
  60 POKE 16525,VAL H$(5 TO )
  70 RAND USR 16514
  80 CLS 
 100 LET C=10
 110 LET L=C
 120 LET CD=1
 130 LET SD=CD
 140 LET D=PEEK 16396+256*PEEK 16397+1
 150 IF C=0 OR C=31 THEN LET CD=-CD
 160 IF L=0 OR L=21 THEN LET SD=-SD
 170 POKE D+L*33+C,0
 180 LET C=C+CD
 190 LET L=L+SD
 200 POKE D+L*33+C,128
 210 GOTO 150
 300 SAVE "RELOGIO ENGLIS"
 310 RUN 

//   Variables Resident in Memory: 
//   
//   none

//include 'SINCL-ZX\ZX81POST.INC'
DFILE_ADDR:
match =COLLAPSED,DFILETYPE {
      collapsed_screen
}
match =EXPANDED,DFILETYPE {
      full_screen
}
match =AUTO,DFILETYPE {
      if MEMAVL>3000
		full_screen
      else
		collapsed_screen
      end if
}
match =DFILETYPE,DFILETYPE {
      collapsed_screen
}
assert (VARS_ADDR-DFILE_ADDR)>24
VARS_ADDR:

     // VARS
     
 db $80
WORKSPACE:
	 ORG		 $+1
STK_BOT:
STK_END: 
;LISTOFF
assert ($-MEMST)<MEMAVL
// end of program